<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>MeiKassenbuch</title>

	<meta name="description" content="Webbasiertes Kassenbuch zur Buchfhrung nach der doppelten Buchfhrung. Version 1.4.2">
	<meta name="keywords" content="Kasse, Kassenbuch, doppelte Buchfhrung, doppelte Buchfuehrung, Buchfhrung, Buchfuehrung">
	<meta name="author" content="Martin Meierhhoefer, martin@meierhoefer.de">
	<meta name="date" content="2019-03-26T12:00:00+01:00">

	<!--
	Copyright (C) 2014, Martin Meierhfer, martin@meierhoefer.de

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as
	published by the Free Software Foundation, either version 3 of the
	License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	-->

	<meta name="viewport" content="user-scalable-no, width=device-width">
	<meta name="apple-mobile-web-app-capable" content="yes" />
	<meta name="apple-mobile-web-app-status-bar-style" content="black" />
	<link rel="apple-touch-icon" href="http://www.domain.de/images/kassenbuch.png">
    
	<style type="text/css">
	<!--
		body {
			background-color: #99ddff;
			color: #222;
			font-family: Helvetica;
			font-size: 14px;
			margin: 0;
			padding: 0;
		}
	-->
	</style>
</head>
<body>

<?php



/****************************************************************
******************* Funktion writeLog ********************
*
* Schreibt den bergebenen Text in ein Logfile und zustzlich den MD5-Hash des Textes.
*/
function writeLog(String $text) {
	$fz = fopen("config/log.txt", "a");
	fprintf($fz, date("Y.m.d-H:i:s:" ,time()));
	fprintf($fz, $text);
	fprintf($fz, "\n");
	fclose($fz);
}
/******************** Ende Funktion writeLog *****************
**********************************************************************/



/*****************************************************************
******************** FunktionkassennameAnlegen ********************
*
* Legt das Verzeichnis files an und in diesem Verzeichnis
* die Dateien 
*	buchungsnummer.txt (enthaelt die Nummer der nchsten Buchung)
*	buchungen.csv (enthaelt alle Buchungen)
*	konten.csv (enthaelt die Uebersicht ueber alle Konten)
*	9000.csv (das Konto 9000 ist das EBK)
*	kassename.txt (in diese Datei steht der Name des Kassenbuchs)
*/
function kassennameAnlegen() {
	exec("mkdir files");
	exec("mkdir config");
	$fz = fopen("files/buchungsnummer.txt", "w");
	fprintf($fz, "1");
        fclose($fz);
	$fz = fopen("files/buchungen.csv", "w");
        fprintf($fz, "Buchungsnummer;Datum;Buchungstext;Sollkonto;Habenkonto;Betrag");
        fclose($fz);
        $fz = fopen("files/konten.csv", "w");
	if (isset($_POST['vereinskonten'])) {
		fprintf($fz, "0300;Vereinsausstattung;1\n");
		fprintf($fz, "0920;Kasse;1\n");
		fprintf($fz, "0940;Girokonto;1\n");
		fprintf($fz, "0950;Sparbuch;1\n");
		fprintf($fz, "1070;Ruecklagen;2\n");
		fprintf($fz, "1170;Eigenkapital;2\n");
		fprintf($fz, "2110;Beitraege;4\n");
		fprintf($fz, "2300;Zuschuesse;4\n");
		fprintf($fz, "2700;Vereinsverwaltung;3\n");
		fprintf($fz, "2900;Ausgaben_ideeller_B;3\n");
		fprintf($fz, "3220;Spenden;4\n");
		fprintf($fz, "4100;Ertrag_Vermoegensverwaltung;4\n");
		fprintf($fz, "4500;Abschreibungen;3\n");
		fprintf($fz, "4510;Aufwand_Vermoegensverwaltung;3\n");
		fprintf($fz, "6500;Ertrag_Zweckbetrieb;4\n");
		fprintf($fz, "6800;Aufwand_Zweckbetrieb;3\n");
		fprintf($fz, "8500;Ertrag_Geschaeftsbetrieb;4\n");
		fprintf($fz, "8650;Aufwand_Geschaeftsbetrieb;3\n");
	}
        fprintf($fz, "9000;EBK;0\n");
        fclose($fz);
	if (isset($_POST['vereinskonten'])) {
		$fz = fopen("files/0300.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/0920.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/0940.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/0950.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/1070.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/1170.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/2110.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/2300.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/2700.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/2900.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/3320.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/4100.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/4500.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/4510.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/6500.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/6800.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/8500.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
		$fz = fopen("files/8650.csv", "w");
		fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		fclose($fz);
	}
        $fz = fopen("files/9000.csv", "w");
        fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
        fclose($fz);
	$fz = fopen("config/kassenname.txt", "w");
	fprintf($fz, "%s\n%s", $_POST[kassenname], hash("md5", $_POST[kennwort]));
	fclose($fz);
	$fz = fopen("config/.htaccess", "w");
	fprintf($fz, "Order allow,deny\n");
	fprintf($fz, "Deny from all\n");
	fclose($fz);
	$logtext = sprintf("Kassenbuch %s angelegt.", $_POST[kassenname]);
	writeLog($logtext);
}
/******************** Ende Funktion kassennameAnlegen *****************
**********************************************************************/



/****************************************************************
******************* Funktion buchungEingeben ********************
*
* Trgt eine Buchung in die beiden beteiligten Konten sowie den Buchungssatz
* in die Datei buchungen.csv ein und erhht den Wert in buchungsnummer.txt.
*/
function buchungEingeben() {

	////////// Eingabewerte berprfen

	$eingabeOK = 1;
	
	if (strtotime($_POST[datum]) === false) {
		printf("<b>Fehler</b>: Das Datum muss im Format tt.mm.yyyy sein!<br>");
		$eingabeOK = 0;
	}
	
	$laengeText = strlen($_POST[buchungstext]);
	if (($laengeText == 0) || ($laengeText != strspn($_POST[buchungstext], "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_%$,./\'> -"))) {
		printf("<b>Fehler</b>: Der Buchungstext darf nicht leer sein und aus Buchstaben, Ziffern und aus folgenden Zeichen bestehen: %% $ , . / \ ' - ><br>");
		$eingabeOK = 0;
	}
	
	$laengeBetrag = strlen($_POST[betrag]);
	if (($laengeBetrag == 0) || ($laengeBetrag != strspn($_POST[betrag], "0123456789,."))) {
		printf("<b>Fehler</b>: Der Betrag darf nur aus Ziffern und dem Komma bestehen und darf nicht leer sein!<br>");
		$eingabeOK = 0;
	}
	
	if ($_POST[Sollkonto] == $_POST[Habenkonto]) {
		printf("<b>Fehler</b>: Soll- und Habenkonto m&uuml;ssen unterschiedlich sein!<br>");
		$eingabeOK = 0;
	}

	if ($eingabeOK) {

		////////// Buchung in die Datei schreiben
		
		$betrag = sprintf("%.2f", $_POST[betrag]);
                $fz = fopen("files/buchungsnummer.txt", "r");
                $input = fgets($fz);
                fclose($fz);
                sscanf($input, "%d", $buchungsnummer);
                $fz = fopen("files/buchungsnummer.txt", "w");
                fprintf($fz, "%d", $buchungsnummer+1);
                fclose($fz);
                $fz = fopen("files/buchungen.csv", "a");
                fprintf($fz, "\n%s;%s;%s;%s;%s;%s", $buchungsnummer, $_POST[datum], $_POST[buchungstext], $_POST[Sollkonto], $_POST[Habenkonto], $betrag);
                fclose($fz);
		$dateiname = sprintf("files/%s.csv", $_POST[Sollkonto]);
                $fz = fopen($dateiname, "a");
                fprintf($fz, "\n%s;%s;%s;%s;%s; ", $_POST[datum], $_POST[buchungstext], $buchungsnummer, $_POST[Habenkonto], $betrag);
                fclose($fz);
		$dateiname = sprintf("files/%s.csv", $_POST[Habenkonto]);
                $fz = fopen($dateiname, "a");
                fprintf($fz, "\n%s;%s;%s;%s; ;%s", $_POST[datum], $_POST[buchungstext], $buchungsnummer, $_POST[Sollkonto], $betrag);
                fclose($fz);
		printf("Buchung mit Nummer %d eingegeben:<br>", $buchungsnummer);
		printf("%s an %s : %s EUR", $_POST[Sollkonto], $_POST[Habenkonto], $betrag);
		
		$logtext = sprintf("Buchung Nr. %d mit Betrag %s und Buchungstext %s.", $buchungsnummer, $betrag, $_POST[buchungstext]);
		writeLog($logtext);
	}
}
/******************** Ende Funktion buchungEingeben ********************
**********************************************************************/



/*******************************************************************************
******************** Funktion ausgabeGUVundSBKaufBildschirm ********************
*
* Gibt die Erfolgskonten in Form einer GuV und Schlussbilanzkonto auf dem Bildschirm aus und
* die Bestandskonten in Form einer Bilanz (= Schlussbilanzkonto).
*/
function ausgabeGUVundSBKaufBildschirm($anzahl, $kontonummer, $kontoname, $kontenart) {
	$guv_soll_anzahl = 0;
	$guv_haben_anzahl = 0;
	$guv_gewinn = 0;
	$bilanz_soll_anzahl = 0;
	$bilanz_haben_anzahl = 0;
		
	////////// Einlesen der Konten und bestimmen des Kontostandes
	for ($i=1; $i<=$anzahl; $i++) {
		$summe = 0;
		$dateiname = sprintf("files/%04d.csv", $kontonummer[$i]);
		$fz = fopen($dateiname, "r");
		while (($input = fgets($fz)) !== false) {
			list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
			$summe = $summe + floatval($soll) - floatval($haben);
		}
		fclose($fz);
		if ($kontenart[$i] == 1) {
			if ($summe<0) {
				$bilanz_haben_anzahl++;
				$bilanz_haben_nr[$bilanz_haben_anzahl] = $kontonummer[$i];
				$bilanz_haben_name[$bilanz_haben_anzahl] = $kontoname[$i];
				$bilanz_haben_betrag[$bilanz_haben_anzahl] = 0-$summe;
			} else {
				$bilanz_soll_anzahl++;
				$bilanz_soll_nr[$bilanz_soll_anzahl] = $kontonummer[$i];
				$bilanz_soll_name[$bilanz_soll_anzahl] = $kontoname[$i];
				$bilanz_soll_betrag[$bilanz_soll_anzahl] = $summe;
			}
		} elseif ($kontenart[$i] == 2) {
			if ($summe<=0) {
				$bilanz_haben_anzahl++;
				$bilanz_haben_nr[$bilanz_haben_anzahl] = $kontonummer[$i];
				$bilanz_haben_name[$bilanz_haben_anzahl] = $kontoname[$i];
				$bilanz_haben_betrag[$bilanz_haben_anzahl] = 0-$summe;
			} else {
				$bilanz_soll_anzahl++;
				$bilanz_soll_nr[$bilanz_soll_anzahl] = $kontonummer[$i];
				$bilanz_soll_name[$bilanz_soll_anzahl] = $kontoname[$i];
				$bilanz_soll_betrag[$bilanz_soll_anzahl] = $summe;
			}
		} elseif ($kontenart[$i] == 3) {
			if ($summe<0) {
				$guv_haben_anzahl++;
				$guv_haben_nr[$guv_haben_anzahl] = $kontonummer[$i];
				$guv_haben_name[$guv_haben_anzahl] = $kontoname[$i];
				$guv_haben_betrag[$guv_haben_anzahl] = 0-$summe;
			} else {
				$guv_soll_anzahl++;
				$guv_soll_nr[$guv_soll_anzahl] = $kontonummer[$i];
				$guv_soll_name[$guv_soll_anzahl] = $kontoname[$i];
				$guv_soll_betrag[$guv_soll_anzahl] = $summe;
			}
			$guv_gewinn = $guv_gewinn - $summe;
		} elseif ($kontenart[$i] == 4) {
			if ($summe<=0) {
				$guv_haben_anzahl++;
				$guv_haben_nr[$guv_haben_anzahl] = $kontonummer[$i];
				$guv_haben_name[$guv_haben_anzahl] = $kontoname[$i];
				$guv_haben_betrag[$guv_haben_anzahl] = 0-$summe;
			} else {
				$guv_soll_anzahl++;
				$guv_soll_nr[$guv_soll_anzahl] = $kontonummer[$i];
				$guv_soll_name[$guv_soll_anzahl] = $kontoname[$i];
				$guv_soll_betrag[$guv_soll_anzahl] = $summe;
			}
			$guv_gewinn = $guv_gewinn - $summe;
		}
	}	

	////////// Ausgabe der Erfolgskonten als GuV
	printf("<center><b>GuV</b><br>");
	printf("<table  width=\"80%%\" border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"3\">");
	printf("<thead><tr><td>Soll</td><td></td><td></td><td></td><td align=\"right\">Haben</td></tr></thead>");

	for ($i=1; $i<=max($guv_haben_anzahl, $guv_soll_anzahl); $i++) {
		printf("<tr>");
		if ($i>$guv_soll_anzahl) {
			printf("<td></td><td></td>");
		} else {
			printf("<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $guv_soll_nr[$i], $guv_soll_name[$i], $guv_soll_betrag[$i]);
		}
		printf("<td>:</td>");
		if ($i>$guv_haben_anzahl) {
			printf("<td></td><td></td>");
		} else {
			printf("<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $guv_haben_nr[$i], $guv_haben_name[$i], $guv_haben_betrag[$i]);
		}
		printf("</tr>");
	}
	printf("<tr><td></td><td align=\"right\">-----</td><td>:</td><td></td><td align=\"right\">-----</td></tr>");
	if ($guv_gewinn < 0) {
		printf("<tr><td></td><td></td><td>:</td><td>Verlust</td><td align=\"right\">%.2f</td></tr>", 0-$guv_gewinn);
	} else {
		printf("<tr><td>Gewinn</td><td align=\"right\">%.2f</td><td>:</td><td></td><td></td></tr>", $guv_gewinn);
	}
	printf("</table></center><p>");
	
	////////// Ausgabe der Bestandskonten als SBK
	printf("<center><b>Schlussbilanzkonto</b><br>");
	printf("<table width=\"80%%\" border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"3\">");
	printf("<thead><tr><td>Aktiva</td><td></td><td></td><td></td><td align=\"right\">Passiva</td></tr></thead>");
		
	for ($i=1; $i<=max($bilanz_haben_anzahl, $bilanz_soll_anzahl); $i++) {
		printf("<tr>");
		if ($i>$bilanz_soll_anzahl) {
			printf("<td></td><td></td>");
		} else {
			printf("<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $bilanz_soll_nr[$i], $bilanz_soll_name[$i], $bilanz_soll_betrag[$i]);
		}
		printf("<td>:</td>");
		if ($i>$bilanz_haben_anzahl) {
			printf("<td></td><td></td>");
		} else {
			printf("<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $bilanz_haben_nr[$i], $bilanz_haben_name[$i], $bilanz_haben_betrag[$i]);
		}
		printf("</tr>");
	}
	if ($guv_gewinn < 0) {
		printf("<tr><td>GuV</td><td align=\"right\">%.2f</td><td>:</td><td></td><td></td></tr>", 0-$guv_gewinn);
	} else {
		printf("<tr><td></td><td></td><td>:</td><td>GuV</td><td align=\"right\">%.2f</td></tr>", $guv_gewinn);
	}
	printf("</table></center><p>");
}
/******************** Ende Funktion ausgabeGUVundSBKaufBildschirm ********************
**************************************************************************************/



/*************************************************************************
******************* Funktion ausgabeKontoaufBildschirm ********************
*
* Gibt die Buchungen eines Kontos mit dem Stand des Kontos auf dem Bildschirm aus.
*/
function ausgabeKontoaufBildschirm() {
	$summe = 0;
	printf("<center><b>Konto %s</b><br>", $_POST[kontonummer]);
	printf("<table width=\"80%%\" border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"1\"><thead><tr><td>Datum</td><td>Buchungstext</td><td>Buchungsnummer</td><td>Gegenkonto</td><td align=\"right\">Soll</td><td align=\"right\">Haben</td></tr></thead>");
	$dateiname = sprintf("files/%s.csv", $_POST[kontonummer]);
	$fz = fopen($dateiname, "r");
	fgets($fz);
	while (($input = fgets($fz)) !== false) {
		list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
		printf("<tr><td>%s</td><td>%s</td><td align=\"center\">%s</td><td>%s</td><td align=\"right\">%s</td><td align=\"right\">%s</td></tr>", $datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben);
		$summe =$summe + floatval($soll) - floatval($haben);
   	}
	fclose($fz);
	printf("<tfoot><tr><td></td><td><b>aktueller Stand</b></td><td></td><td></td>");
	if ($summe < 0) {
		printf("<td></td><td align=\"right\"><b>%.2f</b></td></tr></tfoot>", 0-$summe);
	} else {
		printf("<td align=\"right\"><b>%.2f</b></td><td></td></tr></tfoot>", $summe);
	}
	printf("</table></center><p>");
}
/******************** Ende Funktion ausgabeKontoaufBildschirm ********************
********************************************************************************/



/*******************************************************************
******************** Funktion kassenbuchLoeschen ********************
*
* Lscht das Kassenbuch und bernimmt je nach POST-Parameter kontenUebernehmen die
* Konten und deren Inhalte.
* kontenUebernehmen = 0: es werden keine Konten bernommen
*			= 1: es werden die Bestandskonten leer bernommen
*                      	= 2: die Bestandskonten werden mit Inhalt bernommen
*			= 3: die Bestandskonten werden mit Inhalt, die Erfolgskonten leer bernommen
*/
function kassenbuchLoeschen() {
	if ($_POST[bestaetigung] == "clear"){
		if ($_POST[kontenUebernehmen] !== "0") {
			$anzahl = 0;
			$gewinn = 0;
			$fp = fopen("files/konten.csv", "r");
			while (($input = fgets($fp)) !== false) {
				list($kontonummer, $kontoname, $input) = explode(";", $input);
				sscanf($input, "%d", $kontenart);
				$summe = 0;
				if (($_POST[kontenUebernehmen] == "2")|| ($_POST[kontenUebernehmen] == "3")) {
					$dateiname = sprintf("files/%s.csv", $kontonummer);
					$fz = fopen($dateiname, "r");
					while (($input = fgets($fz)) !== false) {
						list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
						$summe = $summe + floatval($soll) - floatval($haben);
					}
					fclose($fz);
					$alt_kontostand[$anzahl] = $summe;
				}
				if (($kontenart == 1)||($kontenart == 2)) {
					$alt_kontonummer[$anzahl] = $kontonummer; 
					printf("Konto %4d gelesen<br>\n", $alt_kontonummer[$anzahl]);
					$alt_kontoname[$anzahl] = $kontoname;
					if ($kontenart == 1)
						$alt_kontenart[$anzahl] = "1";
					else
						$alt_kontenart[$anzahl] = "2";
					$alt_kontostand[$anzahl] = $summe;
					$anzahl++;
				} elseif (($kontenart == 3)||($kontenart == 4)) {
					if ($_POST[kontenUebernehmen] == "3") {
						$alt_kontonummer[$anzahl] = $kontonummer;
						printf("Konto %4d gelesen<br>\n", $alt_kontonummer[$anzahl]);
						$alt_kontoname[$anzahl] = $kontoname;
						if ($kontenart == 3)
							$alt_kontenart[$anzahl] = "3";
						else
							$alt_kontenart[$anzahl] = "4";
						$alt_kontostand[$anzahl] = 0;
						$anzahl++;
					}
					$gewinn = $gewinn + $summe;
				}
			}
			fclose($fp);
		}
		if ($_POST[kontenUebernehmen] == "2") {
			$eigenkapital = $_POST[eigenkapital1];
		} else if ($_POST[kontenUebernehmen] == "3") {
			$eigenkapital = $_POST[eigenkapital2];
		}
		for ($i=0; $i<$anzahl; $i++) {
			$kto = sprintf("%04d", $alt_kontonummer[$i]);
			if ($kto == $eigenkapital) {
				$alt_kontostand[$i] = $alt_kontostand[$i] + $gewinn;
			}
		}
		$zeit = strftime("%y%m%d%H%M%S", time());
		$command = sprintf("mkdir %s", $zeit);
		exec($command, $output, $return);
		$command = sprintf("mv files/*.csv %s", $zeit);
		exec($command, $output, $return);
		$buchungsnummer = 1;
		$fz = fopen("files/buchungen.csv", "w");
		fprintf($fz, "Buchungsnummer;Datum;Buchungstext;Sollkonto;Habenkonto;Betrag");
		fclose($fz);
		$fz = fopen("files/konten.csv", "w");
		fprintf($fz, "9000;EBK;0\n");
		if ($_POST[kontenUebernehmen] !== "0") {
			for ($i=0; $i<$anzahl; $i++) {
				fprintf($fz, "%04d;%s;%s\n", $alt_kontonummer[$i], $alt_kontoname[$i], $alt_kontenart[$i]);
			}
		}
		fclose($fz);
		$datum = strftime("%d.%m.%Y", time());
		$fp = fopen("files/9000.csv", "w");
		fprintf($fp, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
		if ($_POST[kontenUebernehmen] !== "0") {
			for ($i=0; $i<$anzahl; $i++) {
				$dateiname = sprintf("files/%04d.csv", $alt_kontonummer[$i]);
				$fz = fopen($dateiname, "w");
				fprintf($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
				if (($_POST[kontenUebernehmen] == "2") || ($_POST[kontenUebernehmen] == "3")) {
					if ($alt_kontostand[$i] != 0) {
						fprintf($fz, "\n%s;Uebertrag Vorjahr %s;%d;9000;", $datum, $alt_kontoname[$i], $buchungsnummer);
						fprintf($fp, "\n%s;Uebertrag Vorjahr %s;%d;%04d;", $datum, $alt_kontoname[$i], $buchungsnummer, $alt_kontonummer[$i]);
						if ($alt_kontostand[$i] < 0) {
							fprintf($fz, ";%.2f", 0-$alt_kontostand[$i]);
							fprintf($fp, "%.2f;", 0-$alt_kontostand[$i]);
						} else {
							fprintf($fz, "%.2f;", $alt_kontostand[$i]);
							fprintf($fp, ";%.2f", $alt_kontostand[$i]);
						}
						$buchungsnummer++;
					}
				}
				fclose($fz);
			}
		}
		fclose($fp);
		$fz = fopen("files/buchungsnummer.txt", "w");
		fprintf($fz, "%d", $buchungsnummer);
		fclose($fz);
		printf("Kassenbuch gel&ouml;scht!");
		
		if ($_POST[kontenUebernehmen] == "0") {
			$logtext = sprintf("Kassenbuch geloescht. Keine Konten uebernommen.");
		} else if ($_POST[kontenUebernehmen] == "1") {
			$logtext = sprintf("Kassenbuch geloescht. Bestandskonten leer uebernommen.");
		} else if ($_POST[kontenUebernehmen] == "2") {
			$logtext = sprintf("Kassenbuch geloescht. Bestandskonten mit Wert uebernommen.");
		} else if ($_POST[kontenUebernehmen] == "3") {
			$logtext = sprintf("Kassenbuch geloescht. Bestandskonten mit Wert und Erfolgskonten leer uebernommen.");
		}
		writeLog($logtext);
	} else {
		printf("Best&auml;tigung fehlerhaft!");
        }
}
/********************************************************************
******************** Funktion kassenbuchLoeschen ********************/



/**************************************************************
********************* Funktion kontoAnlegen ********************
*
* Legt ein Konto mit den Werten der POST-Parameter kontonummer, kontenbezeichnung und kontenart an,
* indem eine Zeile in konten.csv eingetragen und die entsprechende Konto-Datei angelegt wird.
*/
function kontoAnlegen() {

	////////// Prfen auf korrekte Eingabe
	
	$eingabeOK = 1;
	$laengeKontonummer = strlen($_POST[kontonummer]);
	if (($laengeKontonummer < 3) || (laengeKontonummer > 5)) {
		printf("<b>Fehler</b>: Die Kontonummer muss zwischen 3 und 5 Zeichen lang sein!<br>");
		$eingabeOK = 0;
	} else {
		if ($laengeKontonummer != strspn($_POST[kontonummer], "0123456789")) {
			printf("<b>Fehler</b>: Die Kontonummer darf nur aus Ziffern bestehen!<br>");
			$eingabeOK = 0;
		}
	}
	if (strlen($_POST[kontenbezeichnung]) != strspn($_POST[kontenbezeichnung], "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_")) {
		printf("<b>Fehler</b>: Die Bezeichnung des Kontos darf nur aus Buchstaben, Ziffern und dem Unterstrich bestehen!<br>");
		$eingabeOK = 0;
	}

	if ($eingabeOK) {
		
		////////// Prfen, ob Kontonummer bereits vorhanden
	
		$kontoNeu = 1;
		$fp = fopen("files/konten.csv", "r");
		$anzahl = 0;
		if ($fp) {
			while (($input = fgets($fp)) !== false) {
				list($input1 , $input2, $input3) = explode(";", $input);
				if ($input1 == $_POST[kontonummer]) {
					printf("<b>Fehler</b>: Konto bereits vorhanden!<br>");
					$kontoNeu = 0;
				}
			}
			fclose($fp);
		}
	
		////////// neues Konto speichern
	
		if ($kontoNeu) {
			$dateiname = sprintf("files/%04d.csv", $_POST[kontonummer]);
			$fz = fopen($dateiname, "w");
			fputs($fz, "Datum;Buchungstext;Buchungsnummer;Gegenkonto;Soll;Haben");
			fclose($fz);
			$fz = fopen("files/konten.csv", "a");
			$output = sprintf("%04d;%s;%s\n", $_POST[kontonummer], $_POST[kontenbezeichnung], $_POST[kontenart]);
			fputs($fz, $output);
			fclose($fz);
			printf("Konto %s mit Kontonummer %04d angelegt!", $_POST[kontenbezeichnung], $_POST[kontonummer]);
			
			$logtext = sprintf("Konto %s mit Kontonumer %04d angelegt.", $_POST[kontenbezeichnung], $_POST[kontonummer]);
			writeLog($logtext);
		}
	}
}
/********************************************************************
******************** Ende Funktion kontoAnlegen *********************/



/*******************************************************************
********************* Funktion kontenAktualisieren *******************
*
* Aktualisiert die Werte der Datei konten.csv anhand der als POST-Parameter bergebenen
* Werte kontonummerXXX, kontonameXXX und kontoartXXX. Die Anzahl der Konten wird
* als POST-Parameter kontenzahl bergeben.
*/
function kontenAktualisieren() {

	$eingabeOK = 1;

	////////// POST-Parameter in Arrays einlesen

	for ($i=0; $i<$_POST[kontenzahl]; $i++) {
		$nummer = sprintf("kontonummer%04d", $i);
		$name = sprintf("kontoname%04d", $i);
		$art = sprintf("kontoart%04d", $i);
		$ktonummer[$i] = $_POST[$nummer];
		$ktonummer_int[$i] = sscanf($_POST[$nummer], "%d");
		$ktoname[$i] = $_POST[$name];
		$ktoart[$i] = $_POST[$art];
		if (strlen($ktoname[$i]) != strspn($ktoname[$i], "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_")) {
			printf("<b>Fehler</b>: Die Bezeichnung des Kontos darf nur aus Buchstaben, Ziffern und dem Unterstrich bestehen!<br>");
			$eingabeOK = 0;
		}
	}
	
	if ($eingabeOK) {
	
		////////// Arrays nach Kontonummer aufsteigend sortieren
	
		for ($i=0; $i<$_POST[kontenzahl]-1; $i++) {
			for ($j=$i+1; $j<$_POST[kontenzahl]; $j++) {
				if ($ktonummer_int[$i] > $ktonummer_int[$j]) {
					$helpnummer = $ktonummer[$i];
					$helpnummer_int = $ktonummer_int[$i];
					$helpname = $ktoname[$i];
					$helpart = $ktoart[$i];
					$ktonummer[$i] = $ktonummer[$j];
					$ktonummer_int[$i] = $ktonummer_int[$j];
					$ktoname[$i] = $ktoname[$j];
					$ktoart[$i] = $ktoart[$j];
					$ktonummer[$j] = $helpnummer;
					$ktonummer_int[$j] = $helpnummer_int;
					$ktoname[$j] = $helpname;
					$ktoart[$j] = $helpart;
				}
			}
		}
	
		////////// Konton nach konten.csv schreiben
	
		rename("files/konten.csv", "files/konten.old");
		$fz = fopen("files/konten.csv", "w");
		for ($i=0; $i<$_POST[kontenzahl]; $i++) {
			fprintf($fz, "%s;%s;", $ktonummer[$i], $ktoname[$i]);
			if (isset($ktoart[$i])) {
				if ($ktoart[$i] == "0") {
					fprintf($fz, "0");
				} elseif ($ktoart[$i] == "1") {
					fprintf($fz, "1");
				} elseif ($ktoart[$i] == "2") {
					fprintf($fz, "2");
				} elseif ($ktoart[$i] == "3") {
					fprintf($fz, "3");
				} else {
					fprintf($fz, "4");
				}
			} else {
				fprintf($fz, "3");
			}
			fprintf($fz, "\n");
		}
		fclose($fz);
	printf("Konten aktualisiert!<br>");
	
	writeLog("Konten aktualisiert.");
	}
}
/**************************************************************************
******************** Ende Funktion kontenAktualisieren *********************/



/*************************************************************
******************** Funktion htmlErzeugen ********************
*
* Erzeugt eine HTML-Datei kassenbuch_gesamt.html.
* Die HTML-Datei ist fr den Druck optimiert. Die Datei enthlt die GuV-Tabelle, das
* Schlussbilanzkonto, alle Konten einzeln aufgehrt und ein Tabelle mit den Buchungsstzen.
* Beim Ausdruck wird vor jedem Konto ein Seitenumbruch eingefgt.
*/
function htmlErzeugen($anzahl, $kontonummer, $kontoname, $kontenart, $kassenname) {
	$fz = fopen("kassenbuch_gesamt.html", "w");
	fprintf($fz, "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">");
	fprintf($fz, "<html>\n<head>\n");
//	fprintf($fz, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"/>\n");
	fprintf($fz, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-2\"/>\n");
//	fprintf($fz, "<style type=\"text/css\">\n* {\nfont-family: DejaVuSansMono, monospace;\n}\n</style>");
	fprintf($fz, "<title>%s</title>\n</head>\n<body>\n", $kassenname);
	fprintf($fz, "<h1>%s</h1>\n", $kassenname);
	$datum = date("d.m.Y");
	fprintf($fz, "<div align=\"right\">Stand: %s</div>\n", $datum);

	$guv_soll_anzahl = 0;
	$guv_haben_anzahl = 0;
	$guv_gewinn = 0;
	$bilanz_soll_anzahl = 0;
	$bilanz_haben_anzahl = 0;
	$statistik_soll_anzahl = 0;
	$statistik_haben_anzahl = 0;
		
	for ($i=1; $i<=$anzahl; $i++) {
		$summe = 0;
		$dateiname = sprintf("files/%04d.csv", $kontonummer[$i]);
		$fp = fopen($dateiname, "r");
		while (($input = fgets($fp)) !== false) {
			list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
			$summe = $summe + floatval($soll) - floatval($haben);
		}
		fclose($fp);
		if ($kontenart[$i] == 0) {
			if ($summe<0) {
				$statistik_haben_anzahl++;
				$statistik_haben_nr[$statistik_haben_anzahl] = $kontonummer[$i];
				$statistik_haben_name[$statistik_haben_anzahl] = $kontoname[$i];
				$statistik_haben_betrag[$statistik_haben_anzahl] = 0-$summe;
			} else {
				$statistik_soll_anzahl++;
				$statistik_soll_nr[$statistik_soll_anzahl] = $kontonummer[$i];
				$statistik_soll_name[$statistik_soll_anzahl] = $kontoname[$i];
				$statistik_soll_betrag[$statistik_soll_anzahl] = $summe;
			}
		} elseif ($kontenart[$i] == 1) {
			if ($summe<0) {
				$bilanz_haben_anzahl++;
				$bilanz_haben_nr[$bilanz_haben_anzahl] = $kontonummer[$i];
				$bilanz_haben_name[$bilanz_haben_anzahl] = $kontoname[$i];
				$bilanz_haben_betrag[$bilanz_haben_anzahl] = 0-$summe;
			} else {
				$bilanz_soll_anzahl++;
				$bilanz_soll_nr[$bilanz_soll_anzahl] = $kontonummer[$i];
				$bilanz_soll_name[$bilanz_soll_anzahl] = $kontoname[$i];
				$bilanz_soll_betrag[$bilanz_soll_anzahl] = $summe;
			}
		} elseif ($kontenart[$i] == 2) {
			if ($summe<=0) {
				$bilanz_haben_anzahl++;
				$bilanz_haben_nr[$bilanz_haben_anzahl] = $kontonummer[$i];
				$bilanz_haben_name[$bilanz_haben_anzahl] = $kontoname[$i];
				$bilanz_haben_betrag[$bilanz_haben_anzahl] = 0-$summe;
			} else {
				$bilanz_soll_anzahl++;
				$bilanz_soll_nr[$bilanz_soll_anzahl] = $kontonummer[$i];
				$bilanz_soll_name[$bilanz_soll_anzahl] = $kontoname[$i];
				$bilanz_soll_betrag[$bilanz_soll_anzahl] = $summe;
			}
		} elseif ($kontenart[$i] == 3) {
			if ($summe<0) {
				$guv_haben_anzahl++;
				$guv_haben_nr[$guv_haben_anzahl] = $kontonummer[$i];
				$guv_haben_name[$guv_haben_anzahl] = $kontoname[$i];
				$guv_haben_betrag[$guv_haben_anzahl] = 0-$summe;
			} else {
				$guv_soll_anzahl++;
				$guv_soll_nr[$guv_soll_anzahl] = $kontonummer[$i];
				$guv_soll_name[$guv_soll_anzahl] = $kontoname[$i];
				$guv_soll_betrag[$guv_soll_anzahl] = $summe;
			}
			$guv_gewinn = $guv_gewinn - $summe;
		} elseif ($kontenart[$i] == 4) {
			if ($summe<=0) {
				$guv_haben_anzahl++;
				$guv_haben_nr[$guv_haben_anzahl] = $kontonummer[$i];
				$guv_haben_name[$guv_haben_anzahl] = $kontoname[$i];
				$guv_haben_betrag[$guv_haben_anzahl] = 0-$summe;
			} else {
				$guv_soll_anzahl++;
				$guv_soll_nr[$guv_soll_anzahl] = $kontonummer[$i];
				$guv_soll_name[$guv_soll_anzahl] = $kontoname[$i];
				$guv_soll_betrag[$guv_soll_anzahl] = $summe;
			}
			$guv_gewinn = $guv_gewinn - $summe;
		}
	}	

	////////// Ausgabe Schlussbilanzkonto
	
	fprintf($fz, "<h4>Schlussbilanz</h4>");
	fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"3\">");
	fprintf($fz, "<tr><td>Aktiva</td><td></td><td></td><td></td><td align=\"right\">Passiva</td></tr>");
		
	for ($i=1; $i<=max($bilanz_haben_anzahl, $bilanz_soll_anzahl); $i++) {
		fprintf($fz, "<tr>");
		if ($i>$bilanz_soll_anzahl) {
			fprintf($fz, "<td></td><td></td>");
		} else {
			fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $bilanz_soll_nr[$i], $bilanz_soll_name[$i], $bilanz_soll_betrag[$i]);
		}
		fprintf($fz, "<td>:</td>");
		if ($i>$bilanz_haben_anzahl) {
			fprintf($fz, "<td></td><td></td>");
		} else {
			fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $bilanz_haben_nr[$i], $bilanz_haben_name[$i], $bilanz_haben_betrag[$i]);
		}
		fprintf($fz, "</tr>");
	}
	if ($guv_gewinn < 0) {
		fprintf($fz, "<tr><td>GuV</td><td align=\"right\">%.2f</td><td>:</td><td></td><td></td></tr>", 0-$guv_gewinn);
	} else {
		fprintf($fz, "<tr><td></td><td></td><td>:</td><td>GuV</td><td align=\"right\">%.2f</td></tr>", $guv_gewinn);
	}
	fprintf($fz, "</table>\n<p>");

	////////// Ausgabe GuV

	fprintf($fz, "<h4   style=\"page-break-before:always\">Gewinn und Verlust (GuV)</h4>");
	fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"3\">");
	fprintf($fz, "<tr><td>Soll</td><td></td><td></td><td></td><td align=\"right\">Haben</td></tr>");
	
	for ($i=1; $i<=max($guv_haben_anzahl, $guv_soll_anzahl); $i++) {
		fprintf($fz, "<tr>");
		if ($i>$guv_soll_anzahl) {
			fprintf($fz, "<td></td><td></td>");
		} else {
			fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $guv_soll_nr[$i], $guv_soll_name[$i], $guv_soll_betrag[$i]);
		}
		fprintf($fz, "<td>:</td>");
		if ($i>$guv_haben_anzahl) {
			fprintf($fz, "<td></td><td></td>");
		} else {
			fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $guv_haben_nr[$i], $guv_haben_name[$i], $guv_haben_betrag[$i]);
		}
		fprintf($fz, "</tr>");
	}
	fprintf($fz, "<tr><td></td><td align=\"right\">-----</td><td>:</td><td></td><td align=\"right\">-----</td></tr>");
	if ($guv_gewinn < 0) {
		fprintf($fz, "<tr><td></td><td></td><td>:</td><td>SBK (Verlust)</td><td align=\"right\">%.2f</td></tr>", 0-$guv_gewinn);
	} else {
		fprintf($fz, "<tr><td>SBK (Gewinn)</td><td align=\"right\">%.2f</td><td>:</td><td></td><td></td></tr>", $guv_gewinn);
	}
	fprintf($fz, "</table>\n<p>");

	if ($_POST[kurzversion]) {
	
		///////// Ausgabe Zusammenfassung Statistikkonten
		
		fprintf($fz, "<h4  style=\"page-break-before:always\">Zusammenfassung Statistikkonten</h4>");
		fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"3\">");
		fprintf($fz, "<tr><td>Soll</td><td></td><td></td><td></td><td align=\"right\">Haben</td></tr>");
	
		for ($i=1; $i<=max($statistik_haben_anzahl, $statistik_soll_anzahl); $i++) {
			fprintf($fz, "<tr>");
			if ($i>$statistik_soll_anzahl) {
				fprintf($fz, "<td></td><td></td>");
			} else {
				fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $statistik_soll_nr[$i], $statistik_soll_name[$i], $statistik_soll_betrag[$i]);
			}
			fprintf($fz, "<td>:</td>");
			if ($i>$statistik_haben_anzahl) {
				fprintf($fz, "<td></td><td></td>");
			} else {
				fprintf($fz, "<td>(%04d) %s</td><td align=\"right\">%.2f</td>", $statistik_haben_nr[$i], $statistik_haben_name[$i], $statistik_haben_betrag[$i]);
			}
			fprintf($fz, "</tr>");
		}
		fprintf($fz, "</table>\n<p>");
		
		///////// Ausgabe Erffnungsbilanzkonto
		
		$summe = 0;
		fprintf($fz, "<h4 style=\"page-break-before:always\">Er&ouml;ffnungsbilanzkonto (EBK)</h4>");
		fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"1\"><thead><tr><td>Datum</td><td>Buchungstext</td><td>Buchungsnummer</td><td>Gegenkonto</td><td>Soll</td><td>Haben</td></tr></thead>");
		$fp = fopen("files/9000.csv", "r");
		fgets($fp);
		while (($input = fgets($fp)) !== false) {
			list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
			fprintf($fz, "<tr><td>%s</td><td>%s</td><td align=\"center\">%s</td><td>%s</td><td align=\"right\">%s</td><td align=\"right\">%s</td></tr>", $datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben);
			$summe =$summe + floatval($soll) - floatval($haben);
		}
		fclose($fp);
		
		fprintf($fz, "<tr><td></td><td>Saldo");
		if ($summe < 0) {
			fprintf($fz, "</td><td></td><td></td><td align=\"right\"><b>%.2f</b></td><td></td></tr>", 0-$summe);
		} else {
			fprintf($fz, "</td><td></td><td></td><td></td><td align=\"right\"><b>%.2f</b></td></tr>", $summe);
		}
		fprintf($fz, "</table>\n<p>");
	
	} else {

		////////// Ausgabe der einzelnen Konten

		for ($i=1; $i<=$anzahl; $i++) {
			$summe = 0;
			$kontonr = sprintf("%04d", $kontonummer[$i]);
			fprintf($fz, "<h4 style=\"page-break-before:always\">%s %s</h4>", $kontonr, $kontoname[$i]);
			fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"1\"><thead><tr><td>Datum</td><td>Buchungstext</td><td>Buchungsnummer</td><td>Gegenkonto</td><td>Soll</td><td>Haben</td></tr></thead>");
			$dateiname = sprintf("files/%s.csv", $kontonr);
			$fp = fopen($dateiname, "r");
			fgets($fp);
			while (($input = fgets($fp)) !== false) {
				list($datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben) = explode(";", $input);
				fprintf($fz, "<tr><td>%s</td><td>%s</td><td align=\"center\">%s</td><td>%s</td><td align=\"right\">%s</td><td align=\"right\">%s</td></tr>", $datum, $buchungstext, $buchungsnummer, $gegenkonto, $soll, $haben);
				$summe =$summe + floatval($soll) - floatval($haben);
			}
			fclose($fp);
		
			fprintf($fz, "<tr><td></td><td>");
			if (($kontenart[$i] == 3)||($kontenart[$i] == 4)) {
				fprintf($fz, "GuV");
			} elseif (($kontenart[$i] == 1)||($kontenart[$i] == 2)) {
				fprintf($fz, "SBK");
			}
			if ($summe < 0) {
				fprintf($fz, "</td><td></td><td></td><td align=\"right\"><b>%.2f</b></td><td></td></tr>", 0-$summe);
			} else {
				fprintf($fz, "</td><td></td><td></td><td></td><td align=\"right\"><b>%.2f</b></td></tr>", $summe);
			}
			fprintf($fz, "</table>\n<p>");
		}
	
		////////// Ausgabe der Buchungen
	
		$fp = fopen("files/buchungen.csv", "r");
		fprintf($fz, "<h4 style=\"page-break-before:always\">Buchungen</h4>");
		fprintf($fz, "<table border=\"1\" rules=\"groups\" bgcolor=\"white\" cellpadding=\"1\"><tr><td>Buchungsnummer</td><td>Datum</td><td>Buchungstext</td><td>Sollkonto</td><td>Gegenkonto</td><td>Betrag</td></tr>");
		fgets($fp);
		while (($input = fgets($fp)) !== false) {
			list($buchungsnummer, $datum, $buchungstext, $sollkonto, $habenkonto, $betrag) = explode(";", $input);
			fprintf($fz, "<tr><td align=\"center\">%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td align=\"right\">%s</td></tr>\n", $buchungsnummer, $datum, $buchungstext, $sollkonto, $habenkonto, $betrag);
		}
		fprintf($fz, "</table>");
		fclose($fp);
			
		fprintf($fz, "</body>\n</html>\n");
		fclose($fz);
	}
	
	printf("<center><a href=\"kassenbuch_gesamt.html\" target=\"_blank\">Kassenbuch als HTML-Datei herunterladen!</a></center>");
}
/*******************************************************************
******************** Ende Funktion htmlErzeugen ********************/



/************************************************************
******************** Funktion pdfErzeugen ********************
*
* Erzeugt eine RTF-Datei kassenbuch_gesamt.rtf.
* Erzeugt aus der HTML-Datei eine PDF-Datei. 
*/
function pdfErzeugen() {

	$mpdfOK = 1;
	if (file_exists("./mpdf/mpdf.php")) {
		require_once("./mpdf/mpdf.php");
	} elseif (file_exists("../mpdf/mpdf.php")) {
		require_once("../mpdf/mpdf.php");
	} else {
		printf("<b>Fehler</b>: PHP-Klasse mPDF ist nicht verf&uuml;gbar!<br>");
		$mpdfOK = 0;
	}

	if ($mpdfOK) {
		$fz = fopen("kassenbuch_gesamt.html", "rb");
		$html = '';
		while (!feof($fz)) {
			$html .= fread($fz, 8192);
		}
		fclose($fz);
		$mpdf = new mPDF();
		$mpdf->WriteHTML($html);
		$mpdf->Output("kassenbuch_gesamt.pdf", "F");
	
		printf("<p><center><a href=\"kassenbuch_gesamt.pdf\" target=\"_blank\">Kassenbuch als PDF-Datei herunterladen!</a></center>");
	}
}
/******************************************************************
******************** Ende Funktion pdfErzeugen ********************/



/*****************************************************************************
******************** Funktion eingabemaskeKontenBearbeiten ********************
*/
function eingabemaskeKontenBearbeiten($sessionid) {
	printf("<p>\n<center>\n<table width=\"95%%\" border=\"0\" cellpadding=\"5\" bgcolor=\"white\" style=\"border-radius: 15px\">\n");
	printf("<tr><td><h3>Konten bearbeiten</h3>\n");
	printf("<form action=\"index.php\" method=\"post\">\n<table>\n");
	printf("<tr><th>Kontonummer</th><th>Bezeichnung</th><th>Bestandskonto<br>(Aktiva)</th><th>Bestandskonto<br>(Passiva)</th><th>Erfolgskonto<br>(Aufwandskonto)</th><th>Erfolgskonto<br>(Ertragskonto)</th><th>Statistikkonto</th></tr>\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"kontenAktualisieren\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	$fp = fopen("files/konten.csv", "r");
	$anzahl = 0;
	if ($fp) {
		while (($input = fgets($fp)) !== false) {
			list($input1 , $input2, $input3) = explode(";", $input);
			printf("<tr><td>%s<input type=\"hidden\" name=\"kontonummer%04d\" value=\"%s\"></td>", $input1, $anzahl, $input1);
			printf("<td style=\"padding: 0px 10px\"><input name=\"kontoname%04d\" type=\"text\" width=\"30\" maxlength=\"30\" value=\"%s\"></td><td align=\"center\">", $anzahl, $input2);
			printf("<input name=\"kontoart%04d\" type=\"radio\" value=\"1\"", $anzahl); 
			if (strspn($input3, "1") != 0) {
				printf(" checked=\"checked\"");
			}
			printf("></td>\n<td align=\"center\">");
			printf("<input name=\"kontoart%04d\" type=\"radio\" value=\"2\"", $anzahl); 
			if (strspn($input3, "2") != 0) {
				printf(" checked=\"checked\"");
			}
			printf("></td>\n<td align=\"center\">");
			printf("<input name=\"kontoart%04d\" type=\"radio\" value=\"3\"", $anzahl); 
			if (strspn($input3, "3") != 0) {
				printf(" checked=\"checked\"");
			}
			printf("></td>\n<td align=\"center\">");
			printf("<input name=\"kontoart%04d\" type=\"radio\" value=\"4\"", $anzahl);
			if (strspn($input3, "4") != 0) {
				printf(" checked=\"checked\"");
			}
			printf("></td>\n<td align=\"center\">");
			printf("<input name=\"kontoart%04d\" type=\"radio\" value=\"0\"", $anzahl);
			if (strspn($input3, "0") != 0) {
				printf(" checked=\"checked\"");
			}
			printf("></td></tr>");
			$anzahl = $anzahl + 1;
		}
	}
	printf("<input type=\"hidden\" name=\"kontenzahl\" value=\"%d\"></table>\n", $anzahl);
	printf("<input type=\"submit\" value=\"Konten bearbeiten\">");
	fclose($fp);
	printf("</form>\n</td></tr>\n");
	printf("<tr><td bgcolor=\"#99ddff\"></td></tr>\n");
	printf("<tr>\n<td>\n<h3>Konto anlegen</h3>\n<form action=\"index.php\" method=\"post\">\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"kontoAnlegen\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	printf("<table>\n<tr><td>Kontonummer:</td><td><input name=\"kontonummer\" type=\"text\" size=\"6\" maxlength=\"5\"></td>\n");
	printf("<td><input name=\"kontenart\" type=\"radio\" value=\"1\" checked> Bestandskonto (Aktiva)</td></tr>\n");
	printf("<tr><td>Kontenbezeichnung:</td><td> <input name=\"kontenbezeichnung\" type=\"text\" size=\"30\" maxlength=\"30\"></td>\n");
	printf("<td><input name=\"kontenart\" type=\"radio\" value=\"2\"> Bestandskonto (Passiva)</td></tr>\n");
	printf("<tr><td></td><td></td><td><input name=\"kontenart\" type=\"radio\" value=\"3\"> Erfolgskonto (Aufwandskonto)</td></tr>\n");
	printf("<tr><td></td><td></td><td><input name=\"kontenart\" type=\"radio\" value=\"4\"> Erfolgskonto (Ertragskonto)</td></tr>\n");
	printf("<tr><td></td><td></td><td><input name=\"kontenart\" type=\"radio\" value=\"0\"> Statistikkonto</td></tr>\n");
	printf("<tr><td><input type=\"submit\" value=\"Konto anlegen\"></td><td></td></tr>\n</table>\n</form>\n");
	printf("</td></tr>\n");
	printf("<tr><td bgcolor=\"#99ddff\"></td></tr>\n");
	printf("<tr><td>\n");
	printf("<h3>Kassenbuch loeschen</h3>\n<p>\n");
	printf("<form action=\"index.php\" method=\"post\">\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"allesLoeschen\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	printf("<table>\n<tr><td>Bestaetigung: <input name=\"bestaetigung\" type=\"text\" size=\"20\" maxlength=\"20\"></td><td>\n");
	printf("<input name=\"kontenUebernehmen\" type=\"radio\" value=\"0\" checked=\"checked\"></td><td> Konten nicht &uuml;bernehmen</td></tr>\n");
	printf("<tr><td></td><td><input name=\"kontenUebernehmen\" type=\"radio\" value=\"1\"></td><td> Bestandskonten ohne Buchung &uuml;bernehmen</td></tr>\n");
	printf("<tr><td></td><td><input name=\"kontenUebernehmen\" type=\"radio\" value=\"2\"></td><td> Bestandskonten &uuml;bernehmen und Schlussbuchung &uuml;bernehmen</td></tr>\n");
	printf("<tr><td></td><td></td><td>Gewinn/Verlust in Konto <input name=\"eigenkapital1\" type=\"text\" size=\"5\" maxlength=\"4\"> verbuchen.</td></tr>\n");
	printf("<tr><td></td><td><input name=\"kontenUebernehmen\" type=\"radio\" value=\"3\"></td><td> Bestandskonten (inkl. Schlussbuchung) und Erfolgskonten (leer) &uuml;bernehmen</td></tr>\n");
	printf("<tr><td></td><td></td><td>Gewinn/Verlust in Konto <input name=\"eigenkapital2\" type=\"text\" size=\"5\" maxlength=\"4\"> verbuchen.</td></tr>\n");
	printf("<tr><td><input type=\"submit\" value=\"Kassenbuch loeschen\"></td><td></td></tr>\n</table>\n</form>\n");
	printf("Um das Kassenbuch zu loeschen geben Sie als Bestaetigung das Wort <b>clear</b> ein!\n");
	printf("</td></tr>\n");
	printf("<tr><td bgcolor=\"#99ddff\"></td></tr>\n");
	printf("<tr><td>\n");
	printf("<p>\n<form action=\"index.php\" method=\"post\">\n<input type=\"hidden\" name=\"steuerung\" value=\"back\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	printf("<input type=\"submit\" value=\"zur&uuml;ck\">\n</form>\n");
	printf("</td>\n</tr>\n</table>\n</center>\n");
}
/************************************************************************************
********************* Ende Funktion eingabemaskeKontenBearbeiten ********************/



/*******************************************************************************************
******************** Funktion eingabemaskeBuchungEingebenKontenAnzeigen *********************
*/
function eingabemakseBuchungEingebenKontenAnzeigen($anzahl, $kontonummer, $kontoname, $kontenart, $sessionid) {
	printf("<p>\n<center>\n<table width=\"95%%\" border=\"0\" cellpadding=\"5\" bgcolor=\"white\" style=\"border-radius: 15px\">\n");
	printf("<tr><td valign=\"top\">");
	if ($sessionid) {
		printf("<h2>Neue Buchung</h2>\n");
		printf("<form action=\"index.php\" method=\"post\">\n");
		printf("<input type=\"hidden\" name=\"steuerung\" value=\"buchungEingeben\">\n");
		printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
		printf("<table>\n<tr><td>Datum:</td><td><input name=\"datum\" type=\"text\" size=\"10\" maxlength=\"10\"></td></tr>\n");
		printf("<tr><td>Buchungstext:</td><td><input name=\"buchungstext\" type=\"text\" size=\"30\" maxlength=\"30\"></td></tr>\n");
		printf("<tr><td>Sollkonto:</td><td><select name=\"Sollkonto\" size=\"1\">\n");
		for ($i=1; $i<=$anzahl; $i++) {
			printf("<option>%04d</option>", $kontonummer[$i]);
		}
		printf("</select><sup><small>(Mittelverwendung)</small></sup></td></tr>\n<tr><td>Habenkonto:</td><td><select name=\"Habenkonto\" size=\"1\">");
		for ($i=1; $i<=$anzahl; $i++) {
			printf("<option>%04d</option>", $kontonummer[$i]);
		}
		printf("</select><sup><small>(Mittelherkunft)</small></sup></td></tr>\n<tr><td>Betrag:</td><td><input name=\"betrag\" type=\"text\" size=\"10\" maxlength=\"10\"><sup><small>(Bei Betr&auml;gen mit Cent bitte . anstatt , verwenden.)</small></sup></td></tr>\n");
		printf("<tr><td><input type=\"submit\" value=\"Buchung eingeben\"></td><td></td></tr>\n</table>\n</form>\n");
		printf("<h2>Konten bearbeiten</h2>\n<p>\n");
		printf("<form action=\"index.php\" method=\"post\">\n");
		printf("<input type=\"hidden\" name=\"steuerung\" value=\"kontenBearbeiten\">\n");
		printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
		printf("<input type=\"submit\" value=\"Konten bearbeiten\">\n");
		printf("</form>\n");
	} else {
		printf("<h2>Bearbeitung aktivieren</h2>\n");
		printf("<form action=\"index.php\" method=\"post\">\n");
		printf("<input type=\"hidden\" name=\"steuerung\" value=\"bearbeitungAktivieren\">\n");
		printf("Kennwort zur Bearbeitung eingeben:<br>");
		printf("<input name=\"bearbeiterkennwort\" type=\"password\" size=\"20\" maxlength=\"20\">\n");
		printf("<input type=\"submit\" value=\"Aktivieren\">\n");
		printf("</form>");
	}
	printf("</td>\n");
	printf("<td valign=\"top\">\n<h2>Konten</h2>\n<form action=\"index.php\" method=\"post\">\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"kontoAnzeigen\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	printf("Kontonummer: <select name=\"kontonummer\" size=\"1\">\n");
	printf("<option>GuV_Bilanz</option>\n");
	for ($i=1; $i<=$anzahl; $i++) {
		printf("<option>%04d</option>", $kontonummer[$i]);
	}
	printf("</select>\n<input type=\"submit\" value=\"Konto anzeigen\">\n</form>\n<p>\n");
	printf("<b>Download der Konten als csv-Datei:</b><br>\n");
	printf("<a href=\"files/buchungen.csv\" target=_new>Buchungen</a><br>\n");
	$fp = fopen("files/konten.csv", "r");
	if ($fp) {
		while (($input = fgets($fp)) !== false) {
			list($input1 , $input2, $input3) = explode(";", $input);
			printf("<a href=\"files/%s.csv\" target=_new>%s %s</a><br>", $input1, $input1, $input2);
		}
	}
	fclose($fp);
	printf("</td></tr><tr><td bgcolor=\"#99ddff\"></td><td bgcolor=\"#99ddff\"></td></tr>\n");
	printf("<tr><td colspan=\"2\">\n<b>Download des gesamten Kassenbuchs:</b>\n<p>\n");
	printf("<form action=\"index.php\" method=\"post\">\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"htmlErzeugen\">\n");
	printf("<input type=\"hidden\" name=\"sessionid\" value=\"%s\">\n", $sessionid);
	printf("<input type=\"submit\" value=\"Kassenbuch als HTML-Datei erzeugen\"> ");
	printf("<input type=\"checkbox\" name=\"kurzversion\" value=\"true\"> Kurzversion <small><sup>(GuV, Bilanz, EBK und Zusammenfassung der Statistikkonten)</sup></small>\n"); 
	printf("</form>\n</td>\n</tr>\n</table>\n</center>");
}
/************************************************************************************************
******************* Ende Funktion eingabemakseBuchungEingebenKontenAnzeigen *********************/



/***********************************************************************
******************** Funktion bearbeitungAktivieren *********************
*/
function bearbeitungAktivieren($kennwort) {
	if (hash("md5", $_POST[bearbeiterkennwort]) == $kennwort) {
		$sessionid = time();
		$fz = fopen("files/sessionid.txt", "w");
		fprintf($fz, "%s", $sessionid);
		fclose($fz);
		return $sessionid;
	} else {
		printf("<b>Fehler</b>: Falsches Kennwort!<br>");
		return 0;
	}
}
/*****************************************************************************
******************* Ende Funktion bearbeitungAktivieren *********************/



/******************************************************/
/******************************************************/
/******************* Hauptprogramm ********************/

$sessionid = 0;
if (isset($_POST[sessionid])) {
	if (($fz = fopen("files/sessionid.txt", "r")) != NULL) {
		$input = fgets($fz);
		if ($input == $_POST[sessionid]) {
			$sessionid = $input;
		}
		fclose($fz);
	} 
}

if ((isset($_POST[steuerung])) && ($_POST[steuerung] == "nameAnlegen")) {
	kassennameAnlegen();
}

//////////  Test anhand der Datei kassenname.txt, ob das Kassenbuch zum ersten Mal aufgerufen wird

$fz = fopen("config/kassenname.txt", "r");
if ($fz == null) {
	printf("<b>Hinweis:</b><p>Das Kassenbuch wird zum ersten Mal aufgerufen.<br>Sie m&uuml;ssen zun&auml;chst einen Namen f&uuml;r das Kassenbuch vergeben!<p>");
	printf("<form action=\"index.php\" method=\"post\"><br>\n");
	printf("<input type=\"hidden\" name=\"steuerung\" value=\"nameAnlegen\"><br>\n");
	printf("Name des Kassenbuches:<br><input type=\"text\" name=\"kassenname\" size=\"30\" maxlength=\"30\"><br><br>\n");
	printf("Kennwort zum Bearbeiten des Kassenbuchs:<br><input type=\"text\" name=\"kennwort\" size=\"30\" maxlength=\"30\"><br>\n");
	printf("<input type=\"checkbox\" name=\"vereinskonten\" value=\"anlegen\"> Konten nach einem vereinfachten Kontenplan f&uuml; einen gemeinn&uuml;tzigen Verein auf Basis SKR 49 anlegen.<br>\n");
	printf("<input type=\"submit\" value=\"Speichern\"><p>");
	printf("</form><p><br><p>");
} else {

	////////// Einlesen und Ausgabe des Namens des Kassenbuches
	
	$input = fgets($fz);
	$kassenname = str_replace("\n", "", $input);
	printf("<center><h1>%s</h1></center>\n", $kassenname);
	$input = fgets($fz);
	$bearbeiterkennwort = str_replace("\n", "", $input);
	fclose($fz);
	
	////////// Einlesen der Konten aus der Datei konten.csv
	
        $anzahl = 0;
	$fp = fopen("files/konten.csv", "r");
	if ($fp) {
		while (($input = fgets($fp)) !== false) {
			$anzahl++;
			list($input1 , $kontoname[$anzahl], $input2) = explode(";", $input);
			sscanf($input1, "%d", $kontonummer[$anzahl]);
			sscanf($input2, "%d", $kontenart[$anzahl]);
		}
	}
	fclose($fp);
	
	////////// Ablaufsteuerung
	
	if (isset($_POST[steuerung])) {
		if ($_POST[steuerung] == "buchungEingeben") {
			if ($sessionid == 0) {
				printf("SessionID ungueltig!<br>Buchung <b>nicht</b> erfasst!<br>");
			} else {
				buchungEingeben();
			}
		} elseif ($_POST[steuerung] == "kontoAnzeigen") {
		     if ($_POST[kontonummer] =="GuV_Bilanz") {
			ausgabeGuVundSBKaufBildschirm($anzahl, $kontonummer, $kontoname, $kontenart);
		     } else {
			ausgabeKontoaufBildschirm();
		     }
		} elseif ($_POST[steuerung] == "allesLoeschen") {
			kassenbuchLoeschen();
		} elseif ($_POST[steuerung] == "kontoAnlegen") {
			kontoAnlegen();
		} elseif ($_POST[steuerung] == "kontenAktualisieren") {
			kontenAktualisieren();
		} elseif ($_POST[steuerung] == "htmlErzeugen") {
			htmlErzeugen($anzahl, $kontonummer, $kontoname, $kontenart, $kassenname);
		} elseif ($_POST[steuerung] == "pdfErzeugen") {
			htmlErzeugen($anzahl, $kontonummer, $kontoname, $kontenart, $kassenname);
			pdfErzeugen();
		} elseif ($_POST[steuerung] == "bearbeitungAktivieren") {
			$sessionid = bearbeitungAktivieren($bearbeiterkennwort);
		}
	}

	///////////// Eingabemaske

	if ((isset($_POST[steuerung])) && (($_POST[steuerung] == "kontenBearbeiten") || ($_POST[steuerung] == "kontoAnlegen") || ($_POST[steuerung] == "allesLoeschen") || ($_POST[steuerung] == "kontenAktualisieren"))) {
		eingabemaskeKontenBearbeiten($sessionid);
	} else {
		eingabemakseBuchungEingebenKontenAnzeigen($anzahl, $kontonummer, $kontoname, $kontenart, $sessionid);
	}
}
/******************** Ende Hauptprogramm ********************/
/*************************************************************/
/*************************************************************/
?>
<p>
<center>
<a href="hilfe.html" target="_blank">Hilfe</a>
</center>
<p>
MeiKassenbuch 1.4.2 erstellt von <a href="http://www.meierhoefer.de/?Martin" target="_blank">Martin Meierh&ouml;fer</a>
</body>
</html>
